#include "XlibInternal.h"
#include "gr.bkgnd"
#include "crab0mask.mask"
#include "crab0.thing"
#include <setjmp.h>
#define CRAB_MAX 10
#define CRABSIZE 16
#define RootX RootWindowinfo.width
#define RootY RootWindowinfo.height
#define RANDVEL (rnd(7)+4)
#define EVER ;;

#define CRAB_SEEK 0
#define CRAB_EAT 1
#define CRAB_BACK 2
#define CRAB_SIDE 3
#define CRAB_QUERY 4
#define CRAB_LOOK 5
int CrabVectorX[4]={1, 0, -1, 0},
    CrabVectorY[4]={0, 1, 0, -1};

struct crab 
{
  int x,y;
  int facing;
  int dx, dy;
  int state;
  int notongray;
  int waiting;
} crab_buf[CRAB_MAX+1];
int crab_count;

Pixmap RootBkgnd;
Bitmap Crab,CrabMask;
WindowInfo RootWindowinfo;
jmp_buf restart;

main()
{
  int i, XIOErr();
  srandom (getpid());
  setjmp(restart);
  printf("Start over... \n");
  XOpenDisplay();
  XIOErrorHandler(XIOErr);
  XQueryWindow(RootWindow, &RootWindowinfo);
  InitMaps();

  crab_count = 0;

  for (EVER)
    {
      NewCrab();
      for (i=crab_count; i; ) if (crab_buf[--i].waiting) UndrawCrab(i);
      XFlush();
      QueryCrabs();
      for (i=crab_count; i; ) MoveCrab(--i);
      XFlush();
/*      sleep(1); */
    }
}

XIOErr()
{
  longjmp(restart);
}
InitMaps()
{
  RootBkgnd = XMakePixmap(XStoreBitmap(gr_width, gr_height, gr_bits),
			  WhitePixel, BlackPixel);
  Crab = XStoreBitmap(CRABSIZE, CRABSIZE, crab0_bits);
  CrabMask = XStoreBitmap(CRABSIZE+2, CRABSIZE+2, crab0mask_bits);

}

NewCrab()
{
  if (crab_count >= CRAB_MAX) return;
  crab_buf[crab_count].state = 0;
  crab_buf[crab_count].notongray=0;
  crab_buf[crab_count].x = rnd(RootX - 2*CRABSIZE);
  crab_buf[crab_count].y = rnd(RootY - 2*CRABSIZE);
  ChangeMovement(crab_count);
  if (NotOnGray(crab_count)) return;
  printf("%d crabs\n",++crab_count);
}

MoveCrab(n)
     int n;
{
  int dir;
  switch (crab_buf[n].state)
    {
    case CRAB_SEEK:
      UndrawCrab(n);
      crab_buf[n].y += crab_buf[n].dy;
      crab_buf[n].x += crab_buf[n].dx;
      DrawCrab(n);
      crab_buf[n].waiting = 1;
      crab_buf[n].state = CRAB_QUERY;
      break;
    case CRAB_QUERY:
      DrawCrab(n);
      crab_buf[n].waiting = 0;
      if (crab_buf[n].notongray) 
	crab_buf[n].state = CRAB_BACK;
      else crab_buf[n].state = CRAB_SEEK;
      break;
    case CRAB_BACK:
      UndrawCrab(n);
      crab_buf[n].y -= crab_buf[n].dy;
      crab_buf[n].x -= crab_buf[n].dx;
      DrawCrab(n);
      crab_buf[n].waiting = 0;
      crab_buf[n].state = CRAB_SIDE;
      break;
    case CRAB_SIDE:
      dir = rnd(1) * 2 - 1;
      UndrawCrab(n);
      crab_buf[n].y -= dir * sgn(crab_buf[n].dx) * 16;
      crab_buf[n].x += dir * sgn(crab_buf[n].dy) * 16;
      crab_buf[n].dx = sgn(crab_buf[n].dx) * RANDVEL;
      crab_buf[n].dy = sgn(crab_buf[n].dy) * RANDVEL;
      crab_buf[n].waiting=1;
      crab_buf[n].state = CRAB_LOOK;
      break;
    case CRAB_LOOK:
      DrawCrab(n);
      if (crab_buf[n].notongray)
	{
	  register int t;

	  t = crab_buf[n].dx;
	  crab_buf[n].dx = crab_buf[n].dy;
	  crab_buf[n].dy = - t;
	}
      crab_buf[n].waiting = 0;
      crab_buf[n].state = CRAB_SEEK;
      break;
    default:
      printf ("I'm horribly confused!!\n");
    }

  if (crab_buf[n].x < 1)
    { 
      crab_buf[n].x = 5;
      crab_buf[n].dx *= -1;
    }
  if (crab_buf[n].x > RootX-(CRABSIZE+2))
    { 
      crab_buf[n].x = RootX-(CRABSIZE+2);
      crab_buf[n].dx *= -1;
    }

  if (crab_buf[n].y < 1)
    { 
      crab_buf[n].y = 1;
      crab_buf[n].dy *= -1;
    }
  if (crab_buf[n].y > RootY-(CRABSIZE+2))
    { 
      crab_buf[n].y = RootY-(CRABSIZE+2);
      crab_buf[n].dy *= -1;
    }
}

ChangeMovement(n)
     int n;
{
  crab_buf[crab_count].facing = rnd(4);
  crab_buf[crab_count].state = CRAB_SEEK;

  crab_buf[crab_count].dx = CrabVectorX[crab_buf[crab_count].facing] * RANDVEL;
  crab_buf[crab_count].dy = CrabVectorY[crab_buf[crab_count].facing] * RANDVEL;
}
  



UndrawCrab(n)
     int n;
{
  XTileFill(RootWindow, crab_buf[n].x-1, crab_buf[n].y-1,
	    CRABSIZE+2, CRABSIZE+2, RootBkgnd, CrabMask, GXcopy, AllPlanes);
}

DrawCrab(n)
     int n;
{
/*   printf("Crab at: %d %d\nstate: %d\n", crab_buf[n].x, crab_buf[n].y,
	 crab_buf[n].state);
*/
  XTileFill(RootWindow, crab_buf[n].x-1, crab_buf[n].y-1,
	    CRABSIZE+2, CRABSIZE+2, WhitePixmap, CrabMask, GXcopy, AllPlanes);
  XTileFill(RootWindow, crab_buf[n].x, crab_buf[n].y,
	    CRABSIZE, CRABSIZE, BlackPixmap, Crab, GXcopy, AllPlanes);
}

/* This has to be defined to return the largest integer less than or
 * equal to the periodicity of the window background
 */

#define nearest(n) (n & (~0x3))
NotOnGray(n)
     int n;
{
  static short buf[sizeof(gr_bits)/sizeof(short)];
  int i;
/*  printf("Looking at %d %d\n",nearest(crab_buf[n].x),nearest(crab_buf[n].y));
*/
  if (crab_buf[n].x <0) return 1;
  if (crab_buf[n].y <0) return 1;
  if (crab_buf[n].x > RootX-CRABSIZE) return 1;
  if (crab_buf[n].y > RootY-CRABSIZE) return 1;

  XPixmapGetXY(RootWindow, nearest(crab_buf[n].x),nearest(crab_buf[n].y),
	       CRABSIZE, CRABSIZE, buf);

/*
  printf("buf: %04x %04x %04x %04x\n", buf[0], buf[1], buf[2], buf[3]);
  printf("gr:  %04x %04x %04x %04x\n", gr_bits[0], gr_bits[1], gr_bits[2], gr_bits[3]);
*/
  for (i=16; i; )
    { --i;
      if ((short) buf[i] != (short) gr_bits[i]) return(1);
    }
  return(0);
}

rnd(n)
     int n;

{
  long random();

  return (random() % n);
}
  
sgn(n)
     register int n;
{
  if (n > 0) return 1;
  else if (n < 0) return -1;
  else return 0;
}
error()
{
  abort();
}
QueryCrabs ()
{
	register Display *dpy;
	register int i,j;
	int nresult = 0;
	static short buf[200];
	int nrequs;
	if (crab_count == 0) 
	    return;


	for (i=0, nrequs=0;i<crab_count;i++) 
	  if (crab_buf[i].waiting)
	    {
	      register XReq *req;
	      GetReq(X_PixmapGet, RootWindow);
	      req -> func = XYFormat;
	      req->param.s[0] = CRABSIZE;
	      req->param.s[1] = CRABSIZE;
	      req->param.s[2] = nearest(crab_buf[i].x);
	      req->param.s[3] = nearest(crab_buf[i].y);
	      ++nrequs;
	    }
	if (nrequs==0) return;
	/* Reset request number to its old value, so that
	    error packets are processed correctly.  */
	dpy->request -= nrequs;

	for (i=0;i<crab_count;i++) 
	  if (crab_buf[i].waiting)
	    {
	      XRep rep;
	      /* Increment request number so error packets
		 are processed correctly. */
	      dpy->request++;
	      if (!_XReply(dpy, &rep))
	    	error();
	      else {
	        _XRead(dpy, buf, 
		       XYPixmapSize(CRABSIZE, CRABSIZE, dpy->dplanes));
		for (j=16; j; )
		  { --j;
		    if(crab_buf[i].notongray = (buf[j] !=  gr_bits[j])) break;
		  }
		nresult++;
	      }
	    }
	return (nresult);
}
